-- Copyright  2008 Xianghar  <xian@zron.de>
-- All Rights Reserved.
-- This code is not to be modified or distributed without written permission by the author.

local nrfonts = 0

local OldDropDownHide = DropDownList1Button1:GetScript("OnHide")
DropDownList1Button1:SetScript("OnHide", function(...) 
                                      for i=1, nrfonts do
                                            getglobal("DropDownList1Button"..i.."NormalText"):SetFont(STANDARD_TEXT_FONT, UIDROPDOWNMENU_DEFAULT_TEXT_HEIGHT)
                                      end
                                      if OldDropDownHide then OldDropDownHide(...) end
                                  end)

function TotemTimers_GUI_ShowTooltip(textvar, istext)
	local text = textvar
	if not istext then text = getglobal(textvar) end
	if text then
		GameTooltip:SetOwner(this, "ANCHOR_RIGHT")
		GameTooltip:SetText(text, 1,1,1,1,1)
	end
end

local loaded = false

function TotemTimers_GUI_TimeFont_OnLoad(self)
    local sharedmedia = nil
    if LibStub then
        sharedmedia = LibStub:GetLibrary("LibSharedMedia-3.0", true)
    end
    nrfonts = 0
	if sharedmedia then
		local fonts = sharedmedia:List("font")
		local info = {}
		info.notCheckable = 1
		info.func = TotemTimers_GUI_TimeFont_OnClick
		for k,v in pairs(fonts) do
            nrfonts = nrfonts + 1
			local f = sharedmedia:Fetch("font", v)
			info.text = v
			info.arg1 = f
            info.arg2 = v
			UIDropDownMenu_AddButton(info)
			if loaded then getglobal("DropDownList1Button"..k.."NormalText"):SetFont(f, UIDROPDOWNMENU_DEFAULT_TEXT_HEIGHT) end
		end
	end
    loaded = true
end

function TotemTimers_GUI_TimeFont_OnClick(self, newFont, fontName)
	TotemTimers_Settings.TimeFont = newFont
    TotemTimers_Settings.TimeFontName = fontName
	TotemTimers_ProcessSetting("TimeFont")
	TotemTimers_GUI_General:Hide()
	TotemTimers_GUI_General:Show()
end

function TotemTimers_GUI_TimeFont_OnShow(self)
    UIDropDownMenu_SetText(self, TotemTimers_Settings.TimeFontName)
end


function TotemTimers_GUI_TimerBarTexture_OnLoad()
    local sharedmedia = nil
    if LibStub then
        sharedmedia = LibStub:GetLibrary("LibSharedMedia-3.0", true)
    end
	if sharedmedia then
		local fonts = sharedmedia:List("statusbar")
		local info = {}
		info.notCheckable = 1
		info.func = TotemTimers_GUI_TimerBarTexture_OnClick
		for k,v in pairs(fonts) do
			local f = sharedmedia:Fetch("statusbar", v)
			info.text = v
			info.arg1 = f
            info.arg2 = v
			UIDropDownMenu_AddButton(info)
		end
	end
end

function TotemTimers_GUI_TimerBarTexture_OnClick(self, texture, name)
	TotemTimers_Settings.TimerBarTexture = texture
    TotemTimers_Settings.TimerBarTextureName = name
	TotemTimers_ProcessSetting("TimerBarTexture")
	TotemTimers_GUI_General:Hide()
	TotemTimers_GUI_General:Show()
end

function TotemTimers_GUI_TimerBarTexture_OnShow(self)
	UIDropDownMenu_SetText(self, TotemTimers_Settings.TimerBarTextureName)
end

