local TotemTimers_GUI_TrackerArrangeOptions = {
	["horizontal"] = TT_GUI_HORIZONTAL,
	["vertical"] = TT_GUI_VERTICAL,
	["box"] = TT_GUI_BOX,
	["free"] = TT_GUI_FREE,
}

function TotemTimers_GUI_DropdownTrackerArrange_OnLoad()
	local info = {}
	info.notCheckable = 1
	info.func = TotemTimers_GUI_DropdownTrackerArrange_OnClick
	for option, text in pairs(TotemTimers_GUI_TrackerArrangeOptions) do
		info.text = text
		info.arg1 = option
		UIDropDownMenu_AddButton(info)
	end
end

function TotemTimers_GUI_DropdownTrackerArrange_OnClick(self, value)
	TotemTimers_Settings.TrackerArrange = value
	TotemTimers_GUI_Trackers:Hide()
	TotemTimers_GUI_Trackers:Show()
	TotemTimers_OrderTrackers()
end

function TotemTimers_GUI_DropdownTrackerArrange_OnShow(self)
	UIDropDownMenu_SetText(self, TotemTimers_GUI_TrackerArrangeOptions[TotemTimers_Settings.TrackerArrange])	
end

-- tracker time position dropdown menu
local TotemTimers_GUI_TimePosOptions = {
	["LEFT"] = TT_GUI_LEFT,
	["RIGHT"] = TT_GUI_RIGHT,
	["TOP"] = TT_GUI_TOP,
	["BOTTOM"] = TT_GUI_BOTTOM,
}

function TotemTimers_GUI_DropdownTrackerTimePos_OnLoad()
	local info = {}
	info.notCheckable = 1
	info.func = TotemTimers_GUI_DropdownTrackerTimePos_OnClick
	for option, text in pairs(TotemTimers_GUI_TimePosOptions) do
		info.text = text
		info.arg1 = option
		UIDropDownMenu_AddButton(info)
	end
end

function TotemTimers_GUI_DropdownTrackerTimePos_OnClick(self, value)
	TotemTimers_Settings.TrackerTimePos = value
	UIDropDownMenu_SetText(TotemTimers_GUI_DropdownTrackerTimePos, TotemTimers_GUI_TimePosOptions[value])
	TotemTimers_ProcessSetting("TrackerTimePos")
end

function TotemTimers_GUI_DropdownTrackerTimePos_OnShow(self)
	UIDropDownMenu_SetText(TotemTimers_GUI_DropdownTrackerTimePos, TotemTimers_GUI_TimePosOptions[TotemTimers_Settings.TrackerTimePos])	
end