local Icons = TotemTimers_Icons

local TotemTimers_GUI_ShieldButtonOptions = {Icons.LightningShield, Icons.WaterShield, Icons.EarthShield, Icons.TotemicCall}

function TotemTimers_GUI_DropdownShieldButton_OnLoad(self)
	local info = {}
	info.notCheckable = 1
	info.func = TotemTimers_GUI_DropdownShieldButton_OnClick
	for _, text in pairs(TotemTimers_GUI_ShieldButtonOptions) do
		info.text = TotemTimers_Spells[text]
		info.arg1 = text
		info.arg2 = self
		UIDropDownMenu_AddButton(info)
	end
end

function TotemTimers_GUI_DropdownShieldButton_OnClick(self, value, frame)
	if frame:GetName() == "TotemTimers_GUI_DropdownShieldLeftButton" then
		TotemTimers_Settings.ShieldLeftButton = value
		TotemTimers_ProcessSetting("ShieldLeftButton")
	elseif frame:GetName() == "TotemTimers_GUI_DropdownShieldRightButton" then
		TotemTimers_Settings.ShieldRightButton = value
		TotemTimers_ProcessSetting("ShieldRightButton")
	elseif frame:GetName() == "TotemTimers_GUI_DropdownShieldMiddleButton" then
		TotemTimers_Settings.ShieldMiddleButton = value
		TotemTimers_ProcessSetting("ShieldMiddleButton")
	end
	TotemTimers_GUI_Trackers2:Hide()
	TotemTimers_GUI_Trackers2:Show()
end

function TotemTimers_GUI_DropdownShieldLeftButton_OnShow(self)
	UIDropDownMenu_SetText(self, TotemTimers_Spells[TotemTimers_Settings.ShieldLeftButton])
end
function TotemTimers_GUI_DropdownShieldRightButton_OnShow(self)
	UIDropDownMenu_SetText(self, TotemTimers_Spells[TotemTimers_Settings.ShieldRightButton])
end
function TotemTimers_GUI_DropdownShieldMiddleButton_OnShow(self)
	UIDropDownMenu_SetText(self, TotemTimers_Spells[TotemTimers_Settings.ShieldMiddleButton])
end

local TotemTimers_GUI_EarthShieldButtonOptions = {"focus", "target", "targettarget", "player", "recast"}

function TotemTimers_GUI_DropdownEarthShieldButton_OnLoad(self)
	local info = {}
	info.notCheckable = 1
	info.func = TotemTimers_GUI_DropdownEarthShieldButton_OnClick
	for _, text in pairs(TotemTimers_GUI_EarthShieldButtonOptions) do
		if text ~= "recast" then info.text = text
		else info.text = TT_GUI_EARTHRECAST end
		info.arg1 = text
		info.arg2 = self
		UIDropDownMenu_AddButton(info)
	end
end

function TotemTimers_GUI_DropdownEarthShieldButton_OnClick(self, value, frame)
	if frame:GetName() == "TotemTimers_GUI_DropdownEarthShieldLeftButton" then
		TotemTimers_Settings.EarthShieldLeftButton = value
		TotemTimers_ProcessSetting("EarthShieldLeftButton")
	elseif frame:GetName() == "TotemTimers_GUI_DropdownEarthShieldRightButton" then
		TotemTimers_Settings.EarthShieldRightButton = value
		TotemTimers_ProcessSetting("EarthShieldRightButton")
	elseif frame:GetName() == "TotemTimers_GUI_DropdownEarthShieldMiddleButton" then
		TotemTimers_Settings.EarthShieldMiddleButton = value
		TotemTimers_ProcessSetting("EarthShieldMiddleButton")
	elseif frame:GetName() == "TotemTimers_GUI_DropdownEarthShieldButton4" then
		TotemTimers_Settings.EarthShieldButton4 = value
		TotemTimers_ProcessSetting("EarthShieldButton4")
	end
	TotemTimers_GUI_Trackers2:Hide()
	TotemTimers_GUI_Trackers2:Show()
end


function TotemTimers_GUI_DropdownEarthShieldLeftButton_OnShow(self)
	local text = TotemTimers_Settings.EarthShieldLeftButton
	if text == "recast" then text = TT_GUI_EARTHRECAST end
	UIDropDownMenu_SetText(self, text)
end
function TotemTimers_GUI_DropdownEarthShieldRightButton_OnShow(self)
	local text = TotemTimers_Settings.EarthShieldRightButton
	if text == "recast" then text = TT_GUI_EARTHRECAST end
	UIDropDownMenu_SetText(self, TotemTimers_Settings.EarthShieldRightButton)
end
function TotemTimers_GUI_DropdownEarthShieldMiddleButton_OnShow(self)
	local text = TotemTimers_Settings.EarthShieldMiddleButton
	if text == "recast" then text = TT_GUI_EARTHRECAST end
	UIDropDownMenu_SetText(self, TotemTimers_Settings.EarthShieldMiddleButton)
end
function TotemTimers_GUI_DropdownEarthShieldButton4_OnShow(self)
	local text = TotemTimers_Settings.EarthShieldButton4
	if text == "recast" then text = TT_GUI_EARTHRECAST end
	UIDropDownMenu_SetText(self, TotemTimers_Settings.EarthShieldButton4)
end


local TotemTimers_GUI_WeaponBuffs = {Icons.RockbiterWeapon, Icons.WindfuryWeapon, Icons.FlametongueWeapon, Icons.FrostbrandWeapon, Icons.EarthlivingWeapon}

function TotemTimers_GUI_DropdownWeaponBuff_OnLoad(self)
	local info = {}
	info.notCheckable = 1
	info.func = TotemTimers_GUI_DropdownWeaponBuff_OnClick
	for _,buff in pairs(TotemTimers_GUI_WeaponBuffs) do
		if TotemTimers_Spells[buff] then
			info.text = TotemTimers_Spells[buff]
			info.arg1 = buff
			info.arg2 = self
			UIDropDownMenu_AddButton(info)
		end
	end
end

function TotemTimers_GUI_DropdownWeaponBuff_OnClick(self, value, frame)
	local nr = tonumber(strsub(frame:GetName(), strlen(frame:GetName())))
	TotemTimers_Settings.WeaponEnchants[nr] = value
	if TotemTimers_Spells[TotemTimers_Settings.WeaponEnchants[nr]] then
		UIDropDownMenu_SetText(frame, TotemTimers_Spells[TotemTimers_Settings.WeaponEnchants[nr]])	
	end	
	TotemTimers_ProcessSetting("WeaponEnchants")
end

function TotemTimers_GUI_DropdownWeaponBuff_OnShow(self)
	local nr = tonumber(strsub(self:GetName(), strlen(self:GetName())))
	if TotemTimers_Spells[TotemTimers_Settings.WeaponEnchants[nr]] then
		UIDropDownMenu_SetText(self, TotemTimers_Spells[TotemTimers_Settings.WeaponEnchants[nr]])	
	end	
end
