-- Copyright  2008, 2009 Xianghar  <xian@zron.de>
-- All Rights Reserved.
-- This code is not to be modified or distributed without written permission by the author.
-- Current permissions only include curse.com, wowui.worldofwar.net, wowinterface.com and their respective addon updaters

local timercount = {[AIR_TOTEM_SLOT] = 2, [FIRE_TOTEM_SLOT] = 3, [EARTH_TOTEM_SLOT] = 4, [WATER_TOTEM_SLOT] = 2}

local Icons = TotemTimers_Icons
local RaidMembers = {}

local RAID_CLASS_COLORS = CUSTOM_CLASS_COLORS or RAID_CLASS_COLORS

local lastcasted = {}

function TotemTimers_CreateTimers()
	for e = 1,4 do
		local tt = TotemTimers:new(timercount[e])
        if TotemTimers_Settings.TotemsOnTimers[e] then
			local t = TotemTimers_Settings.TotemsOnTimers[e]
			tt.button.icons[1]:SetTexture(t)
			tt.button.miniIcon:SetTexture(t)
			if TotemTimers_Spells[t] then
				tt.button:SetAttribute("*spell1", TotemTimers_Spells[t])
			end
		else
			tt.button.icons[1]:SetTexture(TotemTimers_Settings.TotemOrder[e][1])
		end

        tt.ManaCheckMini = true
		tt.button:SetScript("OnEvent", TotemTimers.TotemEvent)
		tt.spacing = TotemTimers_Settings.TimerSpacing
		tt.events[1] = "PLAYER_TOTEM_UPDATE"
        tt.events[2] = "SPELL_UPDATE_COOLDOWN"
        tt.events[3] = "PLAYER_ENTERING_WORLD"
        tt.events[4] = "UNIT_SPELLCAST_SUCCEEDED"
        tt.events[5] = "UNIT_AURA"
        tt.events[6] = "RAID_ROSTER_UPDATE"
        tt.events[7] = "PLAYER_REGEN_ENABLED"
		--[[tt.button:ClearAllPoints()
		if e == 1 then
			tt.button:SetPoint("CENTER", TotemTimersFrame, "CENTER")
		else
			tt.button:SetPoint("LEFT", TotemTimers.timers[e-1].button, "RIGHT", 5, 0)
		end]]
		tt.button.anchorframe = TotemTimersFrame
		tt.button:RegisterForClicks("LeftButtonUp", "RightButtonUp", "MiddleButtonUp", "Button4Down")
		tt.button:SetAttribute("*type2", "macro")
		tt.button:SetAttribute("*type3", "macro")
		tt.button:SetAttribute("*macrotext2", "/script DestroyTotem("..e..")")		
		tt.button:SetAttribute("*type1", "spell")
		tt.button.UpdateMiniIcon = function(self)
                local spell = self:GetAttribute("*spell1")
                if spell then
                    local t = GetSpellTexture(self:GetAttribute("*spell1"))
                    TotemTimers_Settings.TotemsOnTimers[self.element] = t
                    self.miniIcon:SetTexture(t)
                    TotemTimers.TotemEvent(self, "SPELL_UPDATE_COOLDOWN", self.timer.nr)
                    TotemTimers_UpdateMacro()
                    self.timer.ManaCheck = t
                end
			end
        tt.button.ShowTooltip = function(self)            
            if self.timer and self.element and not IsModifierKeyDown() and TotemTimers_Settings.ShowRaidRangeTooltip then
                if self.timer.timers[1] <= 0 then return end
                local count = TotemTimers_GetMissingBuffs(self.element)
                if count <= 0 then return end
                local missingBuffNames, classes = TotemTimers_GetMissingBuffNames(self.element)
                GameTooltip:ClearLines();
                local left = self:GetLeft()
                if left<UIParent:GetWidth()/2 then
                    GameTooltip:SetOwner(self, "ANCHOR_RIGHT")
                else			
                    GameTooltip:SetOwner(self, "ANCHOR_LEFT")
                end
                for name,_ in pairs(missingBuffNames) do
                    GameTooltip:AddLine(name, RAID_CLASS_COLORS[classes[name]].r, RAID_CLASS_COLORS[classes[name]].g, RAID_CLASS_COLORS[classes[name]].b)
                end
                GameTooltip:Show()
            elseif self:GetAttribute("tooltip") then
                local spell = self:GetAttribute("*spell1")
                if spell and TotemTimers_SpellIDs[spell] then
                    local left = self:GetLeft()
        			if left<UIParent:GetWidth()/2 then
        				GameTooltip:SetOwner(self, "ANCHOR_RIGHT")
        			else			
        				GameTooltip:SetOwner(self, "ANCHOR_LEFT")
        			end
        			GameTooltip:SetSpell(TotemTimers_SpellIDs[spell], BOOKTYPE_SPELL)
                end
            end
         end
        tt.button.HideTooltip = function(self) GameTooltip:Hide() end
		tt.button:SetAttribute("_onenter", [[ control:CallMethod("ShowTooltip")
                                              if not alwaysshow then
                                                   if self:GetAttribute("OpenMenu") == "mouseover" then
                                                       open = true
                                                       control:ChildUpdate("show", "show")
                                                   end
                                               end ]])
		tt.button:SetAttribute("_onleave", [[ control:CallMethod("HideTooltip")
                                              if not alwaysshow and not self:IsUnderMouse(true) then
                                                  open = false control:ChildUpdate("hide", "hide")
                                              end]])
		tt.button:SetAttribute("_onattributechanged", [[ if not alwaysshow and ((name=="hideleave" and not self:IsUnderMouse(true)) or name=="hide") then
															 open = false
                                                             control:ChildUpdate("hide", "hide")	
                                                         elseif name == "*spell1" then 
                                                            control:CallMethod("UpdateMiniIcon")
                                                         end]])
		tt.button:WrapScript(tt.button, "OnClick", [[ if not alwaysshow and (button == self:GetAttribute("OpenMenu")
                                                        or (button == "MiddleButton" and self:GetAttribute("OpenMenu") == "mouseover")
                                                        or (button == "Button4" and down)) then
                                                          open = not open
                                                          if open then
                                                              control:ChildUpdate("show", "show")
                                                          else
                                                              control:ChildUpdate("hide", "hide")
                                                          end
                                                      end ]])
        tt.activate = function(self)
            TotemTimers.activate(self)
            TotemTimers.TotemEvent(self.button, "PLAYER_TOTEM_UPDATE", self.nr)
            TotemTimers.TotemEvent(self.button, "SPELL_UPDATE_COOLDOWN", self.nr)
        end
        
	end
	TotemTimers_CreateCastButtons()
	for i=1,4 do
		TotemTimers.timers[i].button:SetScript("OnDragStop", function(self) TotemTimers.StopMoving(self) TotemTimers_PositionCastButtons() end)
        TotemTimers.timers[i].button:UpdateMiniIcon()
	end
end

local Cooldowns = {
    [EARTH_TOTEM_SLOT] = {
        [2] = TotemTimers_Icons.EarthBind,
        [3] = TotemTimers_Icons.StoneClaw,
        [4] = TotemTimers_Icons.EarthElemental,
    },
    [WATER_TOTEM_SLOT] = {
        [2] = TotemTimers_Icons.ManaTide,
    },
    [FIRE_TOTEM_SLOT] = {
        [2] = TotemTimers_Icons.FireNova,
        [3] = TotemTimers_Icons.FireElemental,
    },
    [AIR_TOTEM_SLOT] = {
        [2] = TotemTimers_Icons.Grounding,
    },
}

function TotemTimers:TotemEvent(event, arg1, arg2)
    local settings = TotemTimers_Settings
    if event == "PLAYER_TOTEM_UPDATE" then
    	if self.element == arg1 then
    		local haveTotem, totem, startTime, duration, icon = GetTotemInfo(arg1)
    		if duration > 0 and totem and icon and TotemData[icon] then
    			self.icons[1]:SetTexture(icon)
                self.timer.activeTotem = icon
    			self.timer.warningMsgs[1] = settings.TotemWarningMsg and string.format(TT_WARNING, totem) or nil
    			self.timer.expirationMsgs[1] = settings.TotemExpirationMsg  and string.format(TT_EXPIRED, totem) or nil
    			self.timer.earlyExpirationMsgs[1] = settings.TotemDestroyedMsg and string.format(TT_DESTROYED, totem) or nil
                if TotemData[icon].flashInterval then
                    self.bar:SetMinMaxValues(0,TotemData[icon].flashInterval)
                    self.timer.bar = TotemData[icon].flashInterval
                else
                    self.timer.bar = nil
                end
    			self.timer:start(1, duration)
    			if settings.SetCastTotems and TotemTimers_Spells[icon] and (not settings.DontAssignHiddenTotems or not settings["Hide"..icon]) then
                    if InCombatLockdown() and settings.AssignLastTotemOOC then
                        lastcasted[self.element] = TotemTimers_Spells[icon]
                    else
                        self:SetAttribute("*spell1", TotemTimers_Spells[icon])
                    end
    			end
                if not TotemData[icon].hasBuff then
                    self.buffCount:SetText("")
                else
                    if settings.CheckPlayerRange then TotemTimers.TotemEvent(self, "UNIT_AURA", "player") end
                    TotemTimers_StartBuffCount(icon, self.element)
                    local count = TotemTimers_GetMissingBuffs(self.element)
                    if count > 0 then
                        self.buffCount:SetText(count)
                    else
                        self.buffCount:SetText("")
                    end
                end
            else
                TotemTimers_ResetBuffCount(self.element)
                self.buffCount:SetText("")
                if self.timer.timers[1] > 0 then 
                    self.timer:stop(1)
                end
    		end
    	end
    elseif event == "SPELL_UPDATE_COOLDOWN" then -- SPELL_UPDATE_COOLDOWN
        local spell = self:GetAttribute("*spell1")
        if spell then
            local start, duration, enable = GetSpellCooldown(spell)
            if start and duration then CooldownFrame_SetTimer(self.cooldown, GetSpellCooldown(spell)) end
        end
        if settings.ShowCooldowns then
            for nr, spell in pairs(Cooldowns[self.timer.nr]) do
                if TotemTimers_Spells[spell] then
                    local start, duration, enable = GetSpellCooldown(TotemTimers_Spells[spell])
					if not start and not duration then
						self.timer:stop(nr)
						return
			        end
                    if duration == 0 then
                        self.timer:stop(nr)
                    elseif duration > 2 and self.timer.timers[nr]<=0 then
                        self.timer:start(nr,start+duration-floor(GetTime()),duration)
                        self.timer.timerbars[nr].icon:SetTexture(spell)
                    end
                elseif self.timer.timers[nr] > 0 then
                    self.timer:stop(nr)
                end 
            end
        else
            for i = 2, self.timer.numtimers do
                self.timer:stop(i)
            end
        end
    elseif (event == "UNIT_SPELLCAST_SUCCEEDED" and arg1 == "player" and arg2 == TotemTimers_Spells[Icons.TotemicCall])
        or event == "PLAYER_ENTERING_WORLD" then
        self.timer.earlyExpirationMsgs[1] = nil
        self.timer.expirationMsgs[1] = nil
        self.timer:stop(1)
    elseif settings.CheckPlayerRange and event == "UNIT_AURA" and arg1 == "player" then
        if self.timer.timers[1]>0 then
            local buffNames = TotemTimers_Settings.BuffNames
            local totem = self.timer.activeTotem
            if not totem or not TotemData[totem].hasBuff then return end
            if not buffNames[totem] then
                buffNames[totem] = TotemTimers_GetBuffName(totem)
                if not buffNames[totem] then return end
            end
            if UnitBuff("player", buffNames[totem]) then
                self.playerdot:Hide()
            else
                self.playerdot:Show()
            end
        end
    elseif settings.CheckRaidRange and event == "UNIT_AURA" and 
        ((string.sub(arg1,1,4) == "raid" and string.sub(arg1, 1, 7) ~= "raidpet")
          or (string.sub(arg1,1,5) == "party" and GetNumRaidMembers()==0)
         ) and not UnitIsUnit(arg1, "player") then
        if self.timer.timers[1] > 0 and TotemData[self.timer.activeTotem].hasBuff then
            TotemTimers_UpdateBuff(arg1, self.timer.activeTotem, self.element)
            local count = TotemTimers_GetMissingBuffs(self.element)
            if count > 0 then
                self.buffCount:SetText(TotemTimers_GetMissingBuffs(self.element))
            else
                self.buffCount:SetText("")
            end
        end
    elseif event == "RAID_ROSTER_UPDATE" then
        if GetNumRaidMembers() == 0 then
            self.buffCount:SetText("")
            TotemTimers_ResetBuffCount(self.element)
        end
    elseif event == "PLAYER_REGEN_ENABLED" and settings.SetCastTotems then
        if lastcasted[self.element] then
            self:SetAttribute("*spell1", lastcasted[self.element])
        end
    end
end


local ButtonPositions = {
	["box"] = {{"CENTER",0,"CENTER"},{"LEFT",1,"RIGHT"},{"TOP",2,"BOTTOM"},{"LEFT",1,"RIGHT"}},
	["horizontal"] = {{"CENTER",0,"CENTER"},{"LEFT",1,"RIGHT"},{"LEFT",1,"RIGHT"},{"LEFT",1,"RIGHT"}},
	["vertical"] = {{"CENTER",0,"CENTER"},{"TOP",1,"BOTTOM"},{"TOP",1,"BOTTOM"},{"TOP",1,"BOTTOM"}}	
}


function TotemTimers_OrderTimers()
	if InCombatLockdown() then return end
	local Timers = TotemTimers.timers
	local Settings = TotemTimers_Settings
	for e=1,4 do
		Timers[e]:ClearAnchors()
		Timers[e].button:ClearAllPoints()
	end
    local c = 0
    local pos = {}
	for e=1,4 do
        if Timers[e].active then
            c = c + 1
            Timers[e].actnr = c
            local arrange = Settings.Arrange
            if arrange ~= "free" then
                if c == 1 then
                    Timers[e]:SetPoint(ButtonPositions[arrange][1][1], TotemTimersFrame, ButtonPositions[arrange][1][3])
                else
                    Timers[e]:Anchor(pos[c-ButtonPositions[arrange][c][2]], ButtonPositions[arrange][c][1])
                end
                Timers[e].savePos = false
            else
                local pos = Settings.TimerPositions[Timers[e].nr]
                if not pos or not pos[1] then pos = {"CENTER", "UIParent", "CENTER", 0,0} end
                Timers[e].button:ClearAllPoints()
                Timers[e].button:SetPoint(pos[1], pos[2], pos[3], pos[4], pos[5])
                Timers[e].savePos = true
            end
            pos[c] = Timers[e]
		end
	end
end

function TotemTimers_CreateCastButtons()
	for i=1,4 do
        TotemTimers.timers[i].CastButtons = {}
		for j=1,7 do
			local b = CreateFrame("Button", "TT_CastButton"..i..j, TotemTimers.timers[i].button, "SecureActionButtonTemplate, SecureHandlerEnterLeaveTemplate, ActionButtonTemplate, SecureHandlerAttributeTemplate")
            TotemTimers.timers[i].CastButtons[j] = b
			b.icon = getglobal("TT_CastButton"..i..j.."Icon")
            b.cooldown = getglobal("TT_CastButton"..i..j.."Cooldown")
			b:Hide()
			b:ClearAllPoints()
			b:SetWidth(36)
			b:SetHeight(36)
			b:SetNormalTexture(nil)
			--b.icon:SetTexture(Icons.RockbiterWeapon)
			b:SetAttribute("_childupdate-show", [[ if self:GetAttribute("alwaysshow") then return end
                                                   if self:GetAttribute("inactive") ~= true then
                                                        self:Show()
                                                        local b = self:GetAttribute("binding")
                                                        if b then
                                                            self:SetBindingClick(true, b, self:GetName())
                                                        end
                                                    end ]])
			b:SetAttribute("_childupdate-hide", [[ if self:GetAttribute("alwaysshow") then return end 
                                                   self:Hide()
                                                   self:ClearBindings(b)]])
			b:SetAttribute("_onleave", [[ control:CallMethod("HideTooltip") if not self:GetAttribute("alwaysshow") then self:GetParent():SetAttribute("hideleave", true) end]])
            b:SetAttribute("_onenter", [[ if IsModifierKeyDown() or self:GetAttribute("tooltip") then control:CallMethod("ShowTooltip") end]])
			--b:SetAttribute("_onclick", [[ if button ~= "LeftButton" then
			--								self:GetParent():SetAttribute("*spell1", self:GetAttribute("*spell1")) 
			--							end
			--							self:GetParent():SetAttribute("hide", true)]])
			TotemTimers.timers[i].button:WrapScript(b, "OnClick", [[ if button ~= "LeftButton" then
																		self:GetParent():SetAttribute("*spell1", self:GetAttribute("*spell1"))
																		control:CallMethod("UpdateMiniIcon")
																	end
																	if not self:GetAttribute("alwaysshow") then self:GetParent():SetAttribute("hide", true) end]])
			b:RegisterForClicks("LeftButtonUp", "RightButtonUp", "MiddleButtonUp")
			b:SetAttribute("*type*", "spell")
            b.ShowTooltip = b:GetParent().ShowTooltip
            b.HideTooltip = b:GetParent().HideTooltip
            b:SetAttribute("_onattributechanged", [[ if name=="inactive" then
                                                         if not value and self:GetAttribute("alwaysshow") then
                                                              self:Show()
                                                         else
                                                             self:Hide()
                                                         end
                                                     elseif name=="alwaysshow" then
                                                        if value then
                                                            if not self:GetAttribute("inactive") then self:Show() end
                                                            local b = self:GetAttribute("binding")
                                                            if b then self:ClearBinding(b) end
                                                        else
                                                            self:Hide()
                                                        end
                                                     end                                                         
                                                    ]])
            b.CastBarAnchor = getglobal("TotemTimers_CastBar"..i)
            b:SetScript("OnDragStart", function(self) if TotemTimers_Settings.OpenMenu == "always" and not TotemTimers_Settings.Lock then self.CastBarAnchor:StartMoving() end end)
            b:SetScript("OnDragStop", function(self) self.CastBarAnchor:StopMovingOrSizing() end)
            b:RegisterForDrag("LeftButton")
            b:RegisterEvent("SPELL_UPDATE_COOLDOWN")
            b:SetScript("OnEvent", function(self)            
                    local spell = self:GetAttribute("*spell1")
                    if spell then
						local start, duration, enable = GetSpellCooldown(spell)
                        if start and duration then CooldownFrame_SetTimer(self.cooldown, start, duration, enable) end
                    end
                end)
		end
	end
	TotemTimers_PositionCastButtons()
end

local CastButtonPositions = {
	["box"] = {
		{["left"] = {"RIGHT", "LEFT", "RIGHT", "LEFT"},["right"] = {"BOTTOM", "TOP", "LEFT", "RIGHT"}},
		{["left"] = {"BOTTOM", "TOP", "RIGHT", "LEFT"},["right"] = {"LEFT", "RIGHT", "LEFT", "RIGHT"}},
		{["left"] = {"RIGHT", "LEFT", "RIGHT", "LEFT"},["right"] = {"TOP", "BOTTOM", "LEFT", "RIGHT"}},
		{["left"] = {"TOP", "BOTTOM", "RIGHT", "LEFT"},["right"] = {"LEFT", "RIGHT", "LEFT", "RIGHT"}}
	},
	["horizontal"] = {
		{["up"] = {"BOTTOM", "TOP", "BOTTOM", "TOP"},["down"]={"TOP", "BOTTOM", "TOP", "BOTTOM"}},
		{["up"] = {"BOTTOM", "TOP", "BOTTOM", "TOP"},["down"]={"TOP", "BOTTOM", "TOP", "BOTTOM"}},
		{["up"] = {"BOTTOM", "TOP", "BOTTOM", "TOP"},["down"]={"TOP", "BOTTOM", "TOP", "BOTTOM"}},
		{["up"] = {"BOTTOM", "TOP", "BOTTOM", "TOP"},["down"]={"TOP", "BOTTOM", "TOP", "BOTTOM"}},
	},
	["vertical"] = {
		{["left"] = {"RIGHT", "LEFT", "RIGHT", "LEFT"},["right"]={"LEFT", "RIGHT", "LEFT", "RIGHT"}},
		{["left"] = {"RIGHT", "LEFT", "RIGHT", "LEFT"},["right"]={"LEFT", "RIGHT", "LEFT", "RIGHT"}},
		{["left"] = {"RIGHT", "LEFT", "RIGHT", "LEFT"},["right"]={"LEFT", "RIGHT", "LEFT", "RIGHT"}},
		{["left"] = {"RIGHT", "LEFT", "RIGHT", "LEFT"},["right"]={"LEFT", "RIGHT", "LEFT", "RIGHT"}},
	},
    ["free"] = {
 		{["left"] = {"RIGHT", "LEFT", "RIGHT", "LEFT"},["right"]={"LEFT", "RIGHT", "LEFT", "RIGHT"},
		["up"] = {"BOTTOM", "TOP", "BOTTOM", "TOP"},["down"]={"TOP", "BOTTOM", "TOP", "BOTTOM"}},
		{["left"] = {"RIGHT", "LEFT", "RIGHT", "LEFT"},["right"]={"LEFT", "RIGHT", "LEFT", "RIGHT"},
		["up"] = {"BOTTOM", "TOP", "BOTTOM", "TOP"},["down"]={"TOP", "BOTTOM", "TOP", "BOTTOM"}},
		{["left"] = {"RIGHT", "LEFT", "RIGHT", "LEFT"},["right"]={"LEFT", "RIGHT", "LEFT", "RIGHT"},
		["up"] = {"BOTTOM", "TOP", "BOTTOM", "TOP"},["down"]={"TOP", "BOTTOM", "TOP", "BOTTOM"}},
		{["left"] = {"RIGHT", "LEFT", "RIGHT", "LEFT"},["right"]={"LEFT", "RIGHT", "LEFT", "RIGHT"},
		["up"] = {"BOTTOM", "TOP", "BOTTOM", "TOP"},["down"]={"TOP", "BOTTOM", "TOP", "BOTTOM"}},
   },
}

function TotemTimers_PositionCastButtons()
	local arr = TotemTimers_Settings.Arrange
    if TotemTimers_Settings.OpenMenu == "always" then arr = "free" end
	local dir = TotemTimers_Settings.CastBarDirection
	if dir == "auto" then
		if arr == "horizontal" then
			local y = TotemTimersFrame:GetTop()
			if y < WorldFrame:GetHeight()/2 then
				dir = "up"
			else
				dir = "down"
			end
		else
			local x = TotemTimersFrame:GetLeft()
			if x < WorldFrame:GetWidth()/2 then
				dir = "right"
			else
				dir = "left"
			end
		end
	end
    local x = 0
    local y = 0
    if TotemTimers_Settings.OpenMenu == "always" then
        if dir == "up" then
            y = TotemTimers_Settings.TotemMenuSpacing
        elseif dir == "down" then
            y = -TotemTimers_Settings.TotemMenuSpacing
        elseif dir == "left" then
            x = -TotemTimers_Settings.TotemMenuSpacing
        else
            x = TotemTimers_Settings.TotemMenuSpacing
        end
    end
	for e = 1,4 do
		local anchor = getglobal("TotemTimers_Timer"..e)
        if TotemTimers_Settings.OpenMenu == "always" then anchor = getglobal("TotemTimers_CastBar"..e) end
		for i = 1,7 do
			local button = getglobal("TT_CastButton"..e..i)
			button:ClearAllPoints()
			if i==1 then
				local point = CastButtonPositions[arr][TotemTimers_Settings.Order[e]][dir][1]
				button:SetPoint(CastButtonPositions[arr][TotemTimers_Settings.Order[e]][dir][1], anchor, CastButtonPositions[arr][TotemTimers_Settings.Order[e]][dir][2])
			else
				button:SetPoint(CastButtonPositions[arr][TotemTimers_Settings.Order[e]][dir][3], getglobal("TT_CastButton"..e..(i-1)), CastButtonPositions[arr][TotemTimers_Settings.Order[e]][dir][4],x,y)
			end
            if TotemTimers_Settings.OpenMenu == "always" then
                button:SetFrameStrata("MEDIUM")
            else
                button:SetFrameStrata("HIGH")
            end
		end
	end
end

function TotemTimers_SetCastButtonSpells()
	for e = 1,4 do
		local count = 1
		for _,totem in pairs(TotemTimers_Settings.TotemOrder[e]) do
			local button = getglobal("TT_CastButton"..e..count)
			if TotemTimers_Spells[totem] and not TotemTimers_Settings["Hide"..totem] then
				button:SetAttribute("*spell1", TotemTimers_Spells[totem])
				button:SetAttribute("*spell3", TotemTimers_Spells[totem])
				button:SetAttribute("inactive", false)
				button.icon:SetTexture(totem)
                local f = button:GetScript("OnEvent")
                if f then f(button) end
				count = count + 1
			end
		end
		for i = count,7 do
			local button = getglobal("TT_CastButton"..e..i)
			button:SetAttribute("inactive", true)
            button:SetAttribute("*spell1", nil)
            button:SetAttribute("*spell3", nil)
            local f = button:GetScript("OnEvent")
            if f then f(button) end
		end
	end
end
