-- Copyright  2008, 2009 Xianghar  <xian@zron.de>
-- All Rights Reserved.
-- This code is not to be modified or distributed without written permission by the author.
-- Current permissions only include curse.com, wowui.worldofwar.net, wowinterface.com and their respective addon updaters


TotemTimers_Icons = {
    StoneSkin = "Interface\\Icons\\Spell_Nature_StoneSkinTotem",
    StoneClaw = "Interface\\Icons\\Spell_Nature_StoneClawTotem",
    EarthBind = "Interface\\Icons\\Spell_Nature_StrengthOfEarthTotem02",
    StrengthOfEarth = "Interface\\Icons\\Spell_Nature_EarthBindTotem",
    Tremor = "Interface\\Icons\\Spell_Nature_TremorTotem",
    EarthElemental = "Interface\\Icons\\Spell_Nature_EarthElemental_Totem",
    
    Searing = "Interface\\Icons\\Spell_Fire_SearingTotem",
    FireNova = "Interface\\Icons\\Spell_Fire_SealOfFire",
    Magma = "Interface\\Icons\\Spell_Fire_SelfDestruct",
    FlameTongue = "Interface\\Icons\\Spell_Nature_GuardianWard",
    FrostResistance = "Interface\\Icons\\Spell_FrostResistanceTotem_01",
    Wrath = "Interface\\Icons\\Spell_Fire_TotemOfWrath",
    FireElemental = "Interface\\Icons\\Spell_Fire_Elemental_Totem",
    
    Cleansing = "Interface\\Icons\\Spell_Nature_DiseaseCleansingTotem",
    HealingStream = "Interface\\Icons\\INV_Spear_04",
    FireResistance = "Interface\\Icons\\Spell_FireResistanceTotem_01",
    ManaSpring = "Interface\\Icons\\Spell_Nature_ManaRegenTotem",
    ManaTide = "Interface\\Icons\\Spell_Frost_SummonWaterElemental",
    
    Grounding = "Interface\\Icons\\Spell_Nature_GroundingTotem",
    NatureResistance = "Interface\\Icons\\Spell_Nature_NatureResistanceTotem",
    Sentry = "Interface\\Icons\\Spell_Nature_RemoveCurse",
    Windfury = "Interface\\Icons\\Spell_Nature_Windfury",
    WrathOfAir = "Interface\\Icons\\Spell_Nature_SlowingTotem",
    
    Ankh = "Interface\\Icons\\Spell_Nature_Reincarnation",
    LightningShield = "Interface\\Icons\\Spell_Nature_LightningShield",
    WaterShield = "Interface\\Icons\\Ability_Shaman_WaterShield",
    EarthShield = "Interface\\Icons\\Spell_Nature_SkinofEarth",
    TotemicCall = "Interface\\Icons\\Spell_unused",
    WindfuryWeapon = "Interface\\Icons\\Spell_Nature_Cyclone",
    RockbiterWeapon = "Interface\\Icons\\Spell_Nature_RockBiter",
    FlametongueWeapon = "Interface\\Icons\\Spell_Fire_FlameTounge",
    FrostbrandWeapon = "Interface\\Icons\\Spell_Frost_FrostBrand",
    EarthlivingWeapon = "Interface\\Icons\\Spell_Shaman_EarthlivingWeapon",
    
    StormStrike = "Interface\\Icons\\Ability_Shaman_Stormstrike",
    EarthShock = "Interface\\Icons\\Spell_Nature_EarthShock",
    FrostShock = "Interface\\Icons\\Spell_Frost_FrostShock",
    FlameShock = "Interface\\Icons\\Spell_Fire_FlameShock",
    LavaLash = "Interface\\Icons\\Ability_Shaman_Lavalash",
    Maelstrom = "Interface\\Icons\\Spell_Shaman_MaelstromWeapon",
    LightningBolt = "Interface\\Icons\\Spell_Nature_Lightning",
    ChainLightning = "Interface\\Icons\\Spell_Nature_ChainLightning",
    
    Reincarnation = "Interface\\Icons\\Spell_Nature_Reincarnation",

}

--[[
1 - Melee
2 - Ranged
3 - Caster
4 - Healer
5 - Hybrid (mostly Enh. Shaman)
]]


TotemData = {
	[TotemTimers_Icons.StoneSkin] = {
		element = EARTH_TOTEM_SLOT,
        hasBuff = true,
        needed = {[1]=true,[2]=true,[3]=true,[4]=true,[5]=true,},
	},
	[TotemTimers_Icons.StrengthOfEarth] = {
		element = EARTH_TOTEM_SLOT,
        hasBuff = true,
        needed = {[1]=true,[2]=true,[5]=true,},
	},
	[TotemTimers_Icons.StoneClaw] = {
		element = EARTH_TOTEM_SLOT,
	},
	[TotemTimers_Icons.Tremor] = {
		element = EARTH_TOTEM_SLOT,
		flashInterval = 3,
		flashDelay = 2.5,
	},
	[TotemTimers_Icons.EarthBind] = {
		element = EARTH_TOTEM_SLOT,
		flashInterval = 3,
		flashDelay = 1.7,
	},
	[TotemTimers_Icons.EarthElemental] = {
		element = EARTH_TOTEM_SLOT,
	},
	[TotemTimers_Icons.Searing] = {
		element = FIRE_TOTEM_SLOT,
	},
	[TotemTimers_Icons.FireNova] = {
		element = FIRE_TOTEM_SLOT,
	},
	[TotemTimers_Icons.Magma] = {
		element = FIRE_TOTEM_SLOT,
	},
	[TotemTimers_Icons.FlameTongue] = {
		element = FIRE_TOTEM_SLOT,
        hasBuff = true,
        needed={[3]=true,[5]=true,},
	},	
	[TotemTimers_Icons.FrostResistance] = {
		element = FIRE_TOTEM_SLOT,
        hasBuff = true,
        needed = {[1]=true,[2]=true,[3]=true,[4]=true,[5]=true,},
	},
	[TotemTimers_Icons.Wrath] = {
		element = FIRE_TOTEM_SLOT,
        hasBuff = true,
        needed = {[3]=true,[5]=true,}
	},
	[TotemTimers_Icons.FireElemental] = {
		element = FIRE_TOTEM_SLOT,
	},	
	[TotemTimers_Icons.Cleansing] = {
		element = WATER_TOTEM_SLOT,
		flashInterval = 3,
		flashDelay = 0,
	},	
	[TotemTimers_Icons.HealingStream] = {
		element = WATER_TOTEM_SLOT,
	},
	[TotemTimers_Icons.FireResistance] = {
		element = WATER_TOTEM_SLOT,
        hasBuff = true,
		needed = {[1]=true,[2]=true,[3]=true,[4]=true,[5]=true,},
	},
	[TotemTimers_Icons.ManaSpring] = {
		element = WATER_TOTEM_SLOT,
		hasBuff = true,
		needed = {[2]=true,[3]=true,[4]=true,[5]=true,},
	},
	[TotemTimers_Icons.ManaTide] = {
		element = WATER_TOTEM_SLOT,
	},
	[TotemTimers_Icons.Grounding] = {
		element = AIR_TOTEM_SLOT,
        hasBuff = true,
        needed = {[1]=true,[2]=true,[3]=true,[4]=true,[5]=true,},
	},
	[TotemTimers_Icons.NatureResistance] = {
		element = AIR_TOTEM_SLOT,
        hasBuff = true,
        needed = {[1]=true,[2]=true,[3]=true,[4]=true,[5]=true,},
    },
	[TotemTimers_Icons.Sentry] = {
		element = AIR_TOTEM_SLOT,
	},
	[TotemTimers_Icons.Windfury] = {
		element = AIR_TOTEM_SLOT,
        hasBuff = true,
        needed = {[1]=true,[5]=true,},
	},
	[TotemTimers_Icons.WrathOfAir] = {
		element = AIR_TOTEM_SLOT,
        hasBuff = true,
        needed = {[3]=true,[4]=true,},
	},
}

TotemTimers_Spells = {}

TT_EMPTY_ICON = "Spell_Totem_WardOfDraining"
