-- Copyright  2008 Xianghar  <xian@zron.de>
-- All Rights Reserved.
-- This code is not to be modified or distributed without written permission by the author.
-- Current permissions only include curse.com, wowui.worldofwar.net, wowinterface.com and their respective addon updaters

local buttonlocations = {
	{"BOTTOM", "TOP"},
	{"BOTTOMLEFT", "TOPRIGHT"},
	{"LEFT", "RIGHT"},
	{"TOPLEFT", "BOTTOMRIGHT"},
	{"TOP", "BOTTOM"},
	{"TOPRIGHT", "BOTTOMLEFT"},
	{"RIGHT", "LEFT"},
	{"BOTTOMRIGHT", "TOPLEFT"},
}

function TotemTimers_InitSetButtons()
    ankh = TotemTimers.timers[5].button
    ankh:SetScript("OnClick", TotemTimers_SetAnchor_OnClick)
    TotemTimers_ProgramSetButtons()
    ankh:WrapScript(TotemTimers.timers[5].button, "OnClick",
                                                            [[ if button == "LeftButton" then
                                                                open = not open
                                                                if open then
                                                                    control:ChildUpdate("show", "show")
                                                                else
                                                                    control:ChildUpdate("hide", "hide")
                                                                end
                                                            end ]])
    ankh:SetAttribute("_onleave", [[if not self:IsUnderMouse(true) then open = false control:ChildUpdate("hide", "hide") end]])
    ankh:SetAttribute("_onattributechanged", [[ if (name=="hideleave" and not self:IsUnderMouse(true)) or name=="hide" then
													open = false
                                                    control:ChildUpdate("hide", "hide")
                                                elseif name=="activateset" then
                                                    control:ChildUpdate("activateset", self:GetAttribute("activateset"))
                                                end ]])
    for i=1,4 do
        TotemTimers.timers[i].button:SetAttribute("_childupdate-activateset", [[ local spell = self:GetAttribute(message)
                                                                                    if spell then 
                                                                                        self:SetAttribute("*spell1", spell)
                                                                                    end ]])
    end
end

function TotemTimers_ProgramSetButtons()
    local Sets = TotemTimers_Settings.TotemSets
	
	local nr = 0
	for i=1,8 do
        local b = getglobal("TotemTimers_SetButton"..i)
        if not b then
            b = CreateFrame("Button", "TotemTimers_SetButton"..i, TotemTimers.timers[5].button, "TotemTimers_SetButtonTemplate")
            b:SetAttribute("_childupdate-show", [[ if not self:GetAttribute("inactive") then self:Show() end ]])
			b:SetAttribute("_childupdate-hide", [[ self:Hide()]])
            b:SetAttribute("_onleave", [[ self:GetParent():SetAttribute("hideleave", true) ]]) 
            b:WrapScript(b, "OnClick", [[ if button == "LeftButton" then self:GetParent():SetAttribute("activateset", "set]]..i..[[") end]])
            b.nr = i
            b:RegisterForClicks("LeftButtonUp", "RightButtonUp")
        end
        b:SetPoint(buttonlocations[i][1], TotemTimers.timers[5].button, buttonlocations[i][2])
        for k = 1,4 do
            if Sets[i] then
                getglobal(b:GetName().."Icon"..k):SetTexture(Sets[i][k])
            else
                getglobal(b:GetName().."Icon"..k):SetTexture(nil)
            end           
        end
        if TotemTimers_Settings.TotemSets[i] then
            b:SetAttribute("inactive", false)
            for k=1,4 do
                TotemTimers.timers[k].button:SetAttribute("set"..i, TotemTimers_Spells[Sets[i][TotemTimers.timers[k].nr]])
            end
        else
            b:SetAttribute("inactive", true)
            for k=1,4 do
                TotemTimers.timers[k].button:SetAttribute("set"..i, nil)
            end
        end
	end
end

function TotemTimers_SetAnchor_OnClick(self, button)
	if button == "RightButton" then
		if InCombatLockdown() or #TotemTimers_Settings.TotemSets >= 8 then return end
        local set = {}
		for i=1,4 do
            local nr = TotemTimers.timers[i].nr
            local spell = TotemTimers.timers[i].button:GetAttribute("*spell1")
            if not spell then
                DEFAULT_CHAT_FRAME:AddMessage(getglobal("TT_NOSPELL"..nr))
                return
            end
			set[nr] = GetSpellTexture(spell)
		end
        table.insert(TotemTimers_Settings.TotemSets, set)
		TotemTimers_ProgramSetButtons()
	end
end

function TotemTimers_SetButton_OnClick(frame, button)
	if button == "RightButton" then
		local popup = StaticPopup_Show("TOTEMTIMERS_DELETESET", frame.nr)
		popup.data = frame.nr
	end
end

local function TotemTimers_DeleteSet(self, nr)
	if not InCombatLockdown() then
		table.remove(TotemTimers_Settings.TotemSets,nr)
		TotemTimers_ProgramSetButtons()
	end
end

StaticPopupDialogs["TOTEMTIMERS_DELETESET"] = {
  text = TT_DELETE_TOTEM_SET,
  button1 = TEXT(OKAY),
  button2 = TEXT(CANCEL),
  whileDead = 1,
  hideOnEscape = 1,
  timeout = 0,
  OnAccept = TotemTimers_DeleteSet,
}